/*
NAME: ThunderBrowse Bookmarks
AUTH: GameSpotting! Networks
DESC: Deals with the bookmarks menu and public bookmarks functions.
*/
var mybookmarks = thunderbrowseprefs.getCharPref("bookmarks").split("[");
var ThunderBrowseBookmarks = {
 closeBookmarksMenu : function()
 {
    if(document.getElementById("tb-bookmarks-popup"))
    document.getElementById("tb-bookmarks-popup").hidePopup();
 },
 middleClickLoad : function(event)
 {
    var mousebutton = event.button;
 	//this is the url for the bookmark
	var urltoload = event.target.getAttribute("url");
	if(mousebutton == 1 || (TBrowseTabChooser.gettabType() == 2 && TBrowseTabChooser.isThunderBrowseTab == false))
		ThunderTabBrowser.addTab(urltoload);
	else
		ThunderBrowse.loadURL(urltoload);
    ThunderBrowseBookmarks.closeBookmarksMenu();
 
 },
 encodeMark : function(barkString)
 {
    //encodes strings if they have commas or [] in them
    if(barkString.split(",")[1] != null || barkString.split("[")[1] != null 
    || barkString.split("]")[1] != null || barkString.split("|")[1] != null)
    {
     var encoded = encodeURIComponent(barkString);
     var newstring = "ENC:"+encoded;
     return newstring;
    }
    else
     return barkString; 
 },
 decodeMark : function(barkString)
 {
   //encodes urls if they have commas in them (fixes comma bug)
    if(barkString.split("ENC:")[1] != null)
    {
     var removePrefix = barkString.split("ENC:")[1];
     return decodeURIComponent(removePrefix);
    }
    else
     return barkString; 
 },
 loadBookmark : function(event)
 {
  //this is the url for the bookmark
	var urltoload = event.target.getAttribute("url");
	//if left click, load regularly
	if(event.button != 0)
		ThunderBrowse.loadURL(urltoload); 
    ThunderBrowseBookmarks.closeBookmarksMenu();
 },
 add2List : function()
 {
  	var tableinsert = document.getElementById("tb-bookmarks-popup");
	for(var i = 1; i < thunderbrowseprefs.getCharPref("bookmarks").split("[").length; ++i)
	{
		if(document.getElementById(i))
		{
			//do nothing
		}
		else
		{
			var mysplitsociety = thunderbrowseprefs.getCharPref("bookmarks").split("[")[i].split("|");
			var item = document.createElement("menuitem");
			var bookName = mysplitsociety[0].replace("[","");
			var bookURL = mysplitsociety[1].replace("]","");
			var decodeName = ThunderBrowseBookmarks.decodeMark(bookName);
			var decodeUrl = ThunderBrowseBookmarks.decodeMark(bookURL);
			item.setAttribute("id","bookmark "+[i]);
			item.setAttribute("label",decodeName);
			item.setAttribute("tooltiptext",decodeUrl);
			item.setAttribute("insertafter","addbelow");
			item.setAttribute("url",decodeUrl);
			item.setAttribute("oncommand","ThunderBrowseBookmarks.loadBookmark(event)");
			item.setAttribute("onclick","ThunderBrowseBookmarks.middleClickLoad(event)");
			tableinsert.appendChild(item);
		}
	}
 },
 preList : function()
 {
   	var tbstrings2 = document.getElementById("tbbookstrings");
	var addbookmark = tbstrings2.getString('bookmarkAddString');
	var bookmarkthispage = tbstrings2.getString('bookmarkThisPageString');
	var managebookmarks = tbstrings2.getString('bookmarkManageString');
	var menuthing = document.getElementById("tb-bookmarks-popup");
	var menuitem = document.createElement("menuitem");
	var menuitem2 = document.createElement("menuitem");
	var menuitem3 = document.createElement("menuitem");
	menuitem.setAttribute("label",addbookmark);
	menuitem.setAttribute("oncommand","ThunderBrowseBookmarks.addMark()");
	menuitem.setAttribute("onclick","ThunderBrowseBookmarks.addMark()");
	menuthing.appendChild(menuitem);
	menuitem2.setAttribute("label",bookmarkthispage);
	menuitem2.setAttribute("oncommand","ThunderBrowseBookmarks.addCurrentPage()");
	menuitem2.setAttribute("onclick","ThunderBrowseBookmarks.addCurrentPage()");
	menuthing.appendChild(menuitem2);
	var sep = document.createElement("menuseparator");
	menuthing.appendChild(sep);
	menuitem3.setAttribute("label",managebookmarks);
	menuitem3.setAttribute("oncommand","manageBookmarks()");
	menuitem3.setAttribute("onclick","manageBookmarks()");
	menuthing.appendChild(menuitem3);
	var sep2 = document.createElement("menuseparator");
	sep2.setAttribute("id","addbelow");
	menuthing.appendChild(sep2);
	ThunderBrowseBookmarks.add2List(); 
 },
 addMark : function()
 {
   	var tbstrings2 = document.getElementById("tbbookstrings");
	var destination = tbstrings2.getString('destinationString');
	var bookName = tbstrings2.getString('bookNameString');
	var bookNameTitleString = tbstrings2.getString('bookNameTitleString');
	var bookDestination = tbstrings2.getString('bookDestinationString');
	var bookmark = prompt(bookName,"",bookNameTitleString);
	var urlto = prompt(bookDestination,"http://",destination);
	if(bookmark != null && urlto != null)
	{
	 	var encodeName = ThunderBrowseBookmarks.encodeMark(bookmark);
		var encodeUrl = ThunderBrowseBookmarks.encodeMark(urlto);       
		var newthing = "["+encodeName+"|"+encodeUrl+"]";
		var oldbooks = thunderbrowseprefs.getCharPref("bookmarks");
		var newtoadd = oldbooks+newthing;
		thunderbrowseprefs.setCharPref("bookmarks",newtoadd);
	}
	ThunderBrowseBookmarks.add2List();
    ThunderBrowseBookmarks.closeBookmarksMenu();    
 }, 
 addCurrentPage:function()
 {
   	var tbstrings2 = document.getElementById("tbbookstrings");
	var bookName = tbstrings2.getString('bookNameString');
	var bookNameTitleString = tbstrings2.getString('bookNameTitleString');
	checkBrowser();
	if(tbrowser.contentTitle != null && tbrowser.contentTitle != "" && tbrowser.contentTitle != " ")
		var bookmark = tbrowser.contentTitle;	
	else
		var bookmark = prompt(bookName,"",bookNameTitleString);
	var urlto = TBrowseGlobal.getCurrentURL();
	if(bookmark != null && urlto != null)
	{
		var encodeName = ThunderBrowseBookmarks.encodeMark(bookmark);
		var encodeUrl = ThunderBrowseBookmarks.encodeMark(urlto);       
		var newthing = "["+encodeName+"|"+encodeUrl+"]";
		var oldbooks = thunderbrowseprefs.getCharPref("bookmarks");
		var newtoadd = oldbooks+newthing;
		thunderbrowseprefs.setCharPref("bookmarks",newtoadd);
	}
	ThunderBrowseBookmarks.add2List();
    ThunderBrowseBookmarks.closeBookmarksMenu();
 },
 reloadBookMenu : function()
 {
  	var menuthing = document.getElementById("tb-bookmarks-popup");
	while(menuthing.childNodes.length > 0)
	{
		var removeme = document.getElementById("tb-bookmarks-popup").childNodes[0];
		menuthing.removeChild(removeme);
	}
	ThunderBrowseBookmarks.preList();
 }
};
//manage bookmarks
function manageBookmarks()
{
	window.openDialog('chrome://tbrowse/content/manageCustom.xul','','','1');
    ThunderBrowseBookmarks.closeBookmarksMenu();   
}
