/*
NAME: ThunderBrowse Handler
AUTH: GameSpotting! Networks
DESC: Deals with core functions and other stuff
*/
//Core:
var TBrowserCore = {
metaTimeout: null,
metageturl: null,
origBrowsr: null,
prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
collapseBars: function(fromtabs)
{
  if(document.getElementById("msgNotificationBar"))
   document.getElementById("msgNotificationBar").collapsed = true;
  if(document.getElementById("imip-bar"))
   document.getElementById("imip-bar").collapsed = true;
  if(document.getElementById("attachmentView"))
   document.getElementById("attachmentView").collapsed = true;
  //tabs need an override plus we need to respect the user's settings
  if(document.getElementById("msgHeaderView") && 
  		(thunderbrowseprefs.getBoolPref("removesub") == true || fromtabs == true))
   document.getElementById("msgHeaderView").collapsed = true;
  if(document.getElementById('editMessageBox'))
   document.getElementById('editMessageBox').setAttribute("collapsed",true); 
},
toggleContent: function(state)
{
 checkBrowser();
 if(state != null && (state == true || state == false))
 {
  if(TBrowsePermissions.jsAllowed() == true)
	thunderbrowsejsprefs.setBoolPref("mailnews",state);
  if(TBrowsePermissions.mediaAllowed() == true)
	tbrowser.allowPlugins = tbrowser.docShell.allowPlugins = state;
 }
},
toggleLaunch: function (toWhat)
{
 //network.protocol-handler.external-default
 try
 {     	      	
 if(this.prefs)
   this.prefs.setBoolPref("network.protocol-handler.external-default", toWhat);
 }
 catch(e)
 {
   TBrowseGlobal.tbLogMsg("In windowed mode, prefServ not a function. Modified value discarded.");
 }
},
dumpLaunchInfo: function()
{
  if(this.prefs)
  {
   var curSetting = this.prefs.getBoolPref("network.protocol-handler.external-default");
   TBrowseGlobal.tbLogMsg("TogglePref currently set to: "+curSetting);
  }
  else
   TBrowseGlobal.tbLogMsg("In windowed mode, pref serv not available.");
},
updateSecurityStatus: function()
{
 checkBrowser();
 var newState = tbrowser.securityUI.state;
 if(gTBURLBox)
 {     
     if(newState == 2 || newState == 1310722 || newState == 262144 || newState == 262146 || newState == 1 || newState == 131072 || newState == 1048576)
     {
     if(newState == 1310722)
 	gTBURLBox.inputField.setAttribute("style","background-color:rgb(22, 207, 12);");
     if(newState == 2 || newState == 262144 || newState == 262146)
 	gTBURLBox.inputField.setAttribute("style","background-color:rgb(245, 246, 190);");
     if(newState == 1 || newState == 131072)
 	gTBURLBox.inputField.setAttribute("style","background-color:rgb(255,79,79);");
     if(newState == 1048576)
 	gTBURLBox.inputField.setAttribute("style","background-color:rgb(161,255,127);");
     }
     else if(gTBURLBox.inputField)
 	gTBURLBox.inputField.removeAttribute("style");
 }
},
getWindowTitle : function ()
{
	/* The reason this is seperate is because on other builds of Thunderbird, the window title change will not stick. */
	checkBrowser();
	if(tbrowser && tbrowser != null && thunderbrowseprefs.getBoolPref("changetitle") == true)
	{
		var getVersion = TBrowseDev.getAppVersion();
		if(getVersion != false)
		{
			var appName;
			if(TBrowseGlobal.app == "spicebird")
			  appName = "Synovel Spicebird";
			if(TBrowseGlobal.app == "postbox")
			  appName = "Postbox";
			if(TBrowseGlobal.app == "thunderbird")
			  appName = "Mozilla Thunderbird";
			  
			if(tbrowser.contentTitle != null && (/(^chrome|^about)/i).test(tbrowser.currentURI.spec) == false)	
				document.title = tbrowser.contentTitle+" - "+appName+" "+getVersion; 
			else
				document.title = appName+" "+getVersion;
		}
	}
},
setThrobber: function(state)
{
  var throb = $("navigator-throbber") || $("throbber-box");
  if(throb)
    throb.setAttribute("busy", state);
},
throbberForTab: function(tab)
{
  if(ThunderTabBrowser.selectedTab == tab)
  {
	  TBrowserCore.setThrobber(!(tab.isLoaded));
	  if(tab.isLoaded == false)
		 tab.setAttribute("image", "chrome://global/skin/throbber/Throbber-small.gif");		    
  }
},
getFavicon: function(tab)
{
	var favIconImage = null;
	if(tab == null)
	 tab = document.getElementById("mail-tab");
	
	if(tab.browser && (/(^http(s)?)/i).test(tab.browser.currentURI.scheme) == true)
		favIconImage=tab.browser.currentURI.scheme+'://'+tab.browser.currentURI.host+'/favicon.ico';
	else
	{
		if(gTBFavDeck)
		  gTBFavDeck.setAttribute('selectedIndex',1);
		return;
	}
	
	TBrowserCore.throbberForTab(tab);
	var mailTabTest = (TBrowseGlobal.getTabType() == 1 && tab == document.getElementById("mail-tab") && ThunderTabBrowser.selectedTab != tab && TBrowseGlobal.getTabHandler().currentTabInfo.mode.type != "thunderbrowse");
	if(ThunderTabBrowser.selectedTab == tab || mailTabTest == true)
	{
		if(gTBFavDeck)	
			gTBFavDeck.setAttribute('selectedIndex',0);	 		
		gTBFavico.setAttribute('src',favIconImage); //Sets the urlbar		
	}
	if(TBrowseGlobal.getTabType() == 0 && tab && tab.isLoaded == true) //Sets the tab picture
		tab.setAttribute("image", favIconImage);	

},
favError: function()
{
	gTBFavDeck.setAttribute('selectedIndex','1');
},
doMetaRefresh: function()
{
  var cameFromBrows = this.origBrowsr;
	var geturl = this.metageturl;
	if(cameFromBrows && cameFromBrows != null)
	   tbrowser = cameFromBrows;
	else
	   checkBrowser();
	clearTimeout(this.metaTimeout);
	//because google has bad html
	if(geturl.match("google.com/ig") != null || tbrowser.currentURI.spec.match("www.google.com/accounts/Logout?service=ig") != null)
		var geturl = "http://www.google.com";
				
	if(geturl.match("talkgadget") == null && geturl.match("www.google.com/accounts/Logout?service=ig") == null)
	{
		if(geturl.split("/")[1] != "")
			geturl = tbrowser.currentURI.scheme+"://"+tbrowser.currentURI.host+"/"+geturl;
		ThunderBrowse.loadURL(geturl, cameFromBrows, null, null, 3);
	}
},
getMetaRedirects : function()
{
	checkBrowser();
	this.origBrowsr = null;
	if(TBrowsePermissions.redirectsAllowed() == true)
	{
	 var metatags = tbrowser.contentDocument.defaultView.document.getElementsByTagName("META");
	 this.origBrowsr = ThunderTabBrowser.getBrowserForTab(ThunderTabBrowser.selectedTab);
	 for(var f = 0; f < metatags.length; f++)
	 {
		if(metatags[f].getAttribute("http-equiv") && metatags[f].getAttribute("http-equiv") == "refresh")
		{
			var geturlpart1 = metatags[f].getAttribute("content");
			if(geturlpart1.split(";")[1])
			{
				var gettime = geturlpart1.split(";")[0];
				this.metageturl = geturlpart1.split(";")[1].split("url=")[1].split('"')[0];
				this.metageturl = this.metageturl.replace("'","","g");
        gettime = Number(gettime);
				if(gettime != Number.NaN)
					this.metaTimeout = setTimeout(TBrowserCore.doMetaRefresh, gettime*1000);
				else
				  TBrowserCore.doMetaRefresh();
        break;
			}
		}
	 }
	}
}
};
//Permissions:
var TBrowsePermissions = {
prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
jsAllowed : function()
{
 var jsPrefToggler = this.prefs.getBranch("extensions.tbrowse.").getBoolPref("dojavascript");
 return jsPrefToggler;
},
mediaAllowed : function()
{
 if(TBrowseGlobal.isThunder && TBrowseDev.compareAppVersions("4.0"))
  return this.prefs.getBranch("mailnews.message_display.").getBoolPref("allow_plugins");
 else
  return this.prefs.getBranch("mailnews.message_display.allow.").getBoolPref("plugins");
},
redirectsAllowed : function()
{
  var redirectsAllowed = this.prefs.getBranch("extensions.tbrowse.").getBoolPref("allowRedir");
  if((TBrowseDev.getCurrentURL().search(TBrowseGlobal.mailProtocols) == 0) == true)
  	return false;
  else
	return redirectsAllowed;
},
imagesAllowed: function(browser)
{
 var imgPrefToggler = this.prefs.getBranch("extensions.tbrowse.").getBoolPref("respectImg");
if(imgPrefToggler == true)
{  
	var imgPrefToggler = this.prefs.getBranch("mailnews.message_display.").getBoolPref("disable_remote_image");
   
   if(imgPrefToggler == true)
      browser.docShell.allowImages = false;
   else
      browser.docShell.allowImages = true;
}
else
  browser.docShell.allowImages = true;
},
linksAllowed: function()
{
	return (thunderbrowseprefs.getBoolPref("loadother") == false);
}
};

//Browser Handlers:
function getBrowser()
{
	if(ThunderTabBrowser)
	   return ThunderTabBrowser.getBrowserForTab(ThunderTabBrowser.selectedTab);
	else
		return document.getElementById("messagepane");
}

/* Hook functions: */
var TBrowserHooks = {

	pageUpdate: function()
	{
		TBrowserCore.getMetaRedirects();
		TBrowserCore.updateSecurityStatus();
		TBrowsExtras.checkIfURLsame();
		TBrowserCore.toggleLaunch(true);
		TBrowseGlobal.tbLogMsg("Turn on because page loaded");  
	},
	addGBrowserEl: function(browser2add)
	{
		if(browser2add)
		{
		browser2add.addTab = function(url, refer, postData, loadinbg) { if(url){ThunderTabBrowser.addTab(url,refer,null,postData,loadinbg);} };
		browser2add.loadOneTab = function(url, refer, postData, loadinbg) { if(url) {ThunderTabBrowser.addTab(url,refer,null,postData,loadinbg);}};
		browser2add.selectedTab = function(tab2select) {if(tab2select){ThunderTabBrowser.selectedTab = tab2select; return tab2select;}else{return ThunderTabBrowser.selectedTab;}};
		browser2add.getBrowserForTab = function(tab) { if(tab){return ThunderTabBrowser.getBrowserForTab(tab);}else{if(!ThunderTabBrowser) return document.getElementById('messagepane'); else return document.getElementById('ext-messagepane');}};
		browser2add.removeCurrentTab = function() { ThunderTabBrowser.removeCurrentTab();};
		browser2add.getBrowserAtIndex = function(index) { if(index){return ThunderTabBrowser.getBrowserAtIndex(index);}else{if(!ThunderTabBrowser) return document.getElementById('messagepane'); else return document.getElementById('ext-messagepane');}};
		browser2add.removeTab = function(discardTab) { return ThunderTabBrowser.removeTab(discardTab);};
		browser2add.goBack = function() { TBHistory.goBack(8,this); };
		browser2add.goForward = function() {TBHistory.goForward(this);};
		browser2add.mPanelContainer = ThunderTabBrowser.tabContainer();
		browser2add.tabContainer = ThunderTabBrowser.tabContainer();
		browser2add.loadURI = function(url, referrerUrl, postData) { var canLoadHere = (TBrowseTabChooser.gettabType() == 2 && TBrowseTabChooser.isThunderBrowseTab == false) ? false : true; if(url && canLoadHere){ThunderBrowse.loadURL(url, this, referrerUrl, postData);} else if(url){ThunderTabBrowser.addTab(url,referrerUrl,null,postData,loadinbg);}};   
		}
		else
		TBrowseGlobal.tbLogMsg("Error! Tried to add gBrowser hooks to unreal browser.");
	},
	addWatchLoads: function(browser,tab)
	{
	 if(browser)
	 {
	  browser.addEventListener("DOMContentLoaded",TBrowserHooks.pageUpdate,false);
	  browser.addEventListener("DOMContentLoaded",function(e){tab.isLoaded = true;TBrowserCore.getFavicon(tab);},false);
	  browser.addEventListener("DOMTitleChanged",TBrowserCore.getWindowTitle,false);
	  
	  if(document.getElementById("ThunderBrowsePopup"))
		 browser.addEventListener("DOMContentLoaded",function(z){TBrowseWindow.watchPage(browser);},false);
	 }
	 else
	  TBrowseGlobal.tbLogMsg("Error! Cannot add watch hooks to unreal browser.");
	},
	removeWatchLoads: function(browser,tab)
	{
	 if(browser)
	 {
	  browser.removeEventListener("DOMContentLoaded",TBrowserHooks.pageUpdate,false);
	  browser.removeEventListener("DOMTitleChanged",TBrowserCore.getWindowTitle,false);
	  
	  if(document.getElementById("ThunderBrowsePopup"))
		 browser.removeEventListener("DOMContentLoaded",function(z){TBrowseWindow.watchPage(browser);},false);
	 }
	 else
	  TBrowseGlobal.tbLogMsg("Error! No browser to remove watch hooks from");
	}
};
