/*
NAME: ThunderBrowse Main
AUTH: GameSpotting! Networks
DESC: This file deals with the main fuctions of ThunderBrowse. It contains the url loading (browsing) functions.
*/
var thunderbrowsejsprefs = Ccl["@mozilla.org/preferences-service;1"].getService(Cil.nsIPrefService).getBranch("javascript.allow.");
var thunderbrowsemediaprefs = Ccl["@mozilla.org/preferences-service;1"].getService(Cil.nsIPrefService).getBranch("mailnews.message_display.allow.");

var ThunderBrowse = {

	//Checks the status of the click to see if it was via UI or not.
	checkURLOrigin: function checkURLOrigin(leftclickurl, avoidhistory)
	{
		//they clicked on a link, so uncollapse the urlbar
		if(gTBNavBar && gTBURLBox)
		{
		  gTBNavBar.collapsed = false;
		  var urltypedin = null;
		  //came from the mouse
		  if(leftclickurl)
		  {       
			urltypedin = leftclickurl;
			window.gTBURLBox.value = leftclickurl;  
		  }
		  //came from a dropdown
		  if(avoidhistory != null && avoidhistory == "2")
		  {
			urltypedin = leftclickurl.originalTarget.label;
			window.gTBURLBox.value = urltypedin;
		  }
		  if(!leftclickurl)	
			urltypedin = TBrowseGlobal.getCurrentURL();
		  //go button was pressed but nothing exists so abort
		  if(!urltypedin)                
			return false;
		  //so javascript typing in doesn't hide the message or the headers
		  if(tbrowser.currentURI.scheme == "mailbox" && urltypedin.split("javascript:")[0] == "")
			return false;
		  return urltypedin; 
	  }
	  else
		 return leftclickurl;                                         
	},

	//handles shortcuts, commands and urls missing schemes.
	//This is an internal function.
	handleURL : function handleURL(aUrl, specificBrows, referUrl, postData, specialFlags)
	{
		var theloadthis;
		
		//Check custom commands/shortcuts
		var customCommandsCheck = TBrowseCommands.checkForCustom(aUrl);
		if(customCommandsCheck != "nw" && customCommandsCheck != false)
			theloadthis = customCommandsCheck;
		else if(customCommandsCheck != "nw")
			theloadthis = "http://"+aUrl.replace("http://", "");
		else
		  return 0;

		TBrowserCore.toggleContent(true);
		this.launchURL(theloadthis, specificBrows, referUrl, postData, specialFlags);
	},

	/* 
		Loads a url. 
			aUrl - url to load
			specificBrows - which browser should load it
			referUrl - The referring url
			postData - Data to include in the request
			specialFlags - Internally used flags
	*/
	loadURL : function loadURL(aUrl, specificBrows, referUrl, postData, specialFlags)
	{
		clearTimeout(TBrowserCore.metaTimeout);
		if(specificBrows && specificBrows != null)
			tbrowser = specificBrows;
		else
			checkBrowser();
			
		if(thunderbrowseprefs.getCharPref("gourlback") != tbrowser.currentURI.spec && specialFlags == "4")
		{
			thunderbrowseprefs.setCharPref("gourlback","");
			TBHistory.getFwdHistory(tbrowser.currentURI.spec,tbrowser);
		}
		//3 & 4 = back & 5 = forward
		if(specialFlags != "5" && specialFlags != "4" && specialFlags != "3")
		{
			thunderbrowseprefs.setCharPref("gourlback","");
			thunderbrowseprefs.setCharPref("gourlforward","");
			tbrowser.setAttribute("history-forward", "");
			if(gTBFwd)
			  gTBFwd.setAttribute("disabled",true);
		}
		var urlRecieved = this.checkURLOrigin(aUrl, specialFlags);
		var urlProtocol = null;

						
		if(document.getElementById("ThunderBrowsePopup"))
		{
			var watch = tbrowser.contentDocument.defaultView.document;
	    watch.removeEventListener("mouseover", TBrowseWindow.changeStatusText,false);
	    watch.removeEventListener("mouseout", TBrowseWindow.removeST,false);
		}
		
		try
		{
			var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			urlProtocol = ioService.extractScheme(urlRecieved); 
		}
		catch(e) //handles shortcuts, commands and urls missing schemes.
		{
			this.handleURL(urlRecieved, tbrowser, referUrl, postData, specialFlags); 
		}
		
		var protocolMailCheck = ((TBrowseGlobal.mailProtocols.test(urlProtocol)) == true);
		var otherProtocolCheck = ((TBrowseGlobal.otherProtocols.test(urlProtocol)) == true);
		var notOnMailbox = tbrowser.currentURI.scheme != "mailbox";
		var isXPI = TBrowsExtras.checkIfXPI(urlRecieved);
		
		if(protocolMailCheck == true || otherProtocolCheck == true || isXPI == true)
		{
		  if((/(^mailto)/i).test(urlProtocol) == true && !$("ThunderBrowsePopup")) //Mailto: support
				 ThunderTabBrowser.selectedTab = $('mail-tab');
		  
		  if(protocolMailCheck == true) //if a "danger" protocol (any protocol that has access to the user's mail account)
		  {
		  	  TBrowserCore.toggleContent(false); //disable content
			  if(urlRecieved.split("#").length == "1" || specialFlags == "4" || specialFlags == "3")
				 gDBView.reloadMessage();
			  this.launchURL(urlRecieved, tbrowser, null, null, null);
			  return 0;
		  }
		  
		  if((/(^about|^tbit)/i).test(urlProtocol) == true) //handling about and tbit links are special case
		  {
				this.handleURL(urlRecieved, tbrowser, referUrl, postData, specialFlags); 
				return 0;
		  }
		  
		  if((/(^javascript)/i).test(urlProtocol) == true && TBrowsePermissions.jsAllowed() == true && notOnMailbox == true) //Javascript Support
		  {
				//ask the user if they really, really, really wanted to run javascript
				var protowarnbar = $("tburlstrings").getString('javascriptprotocolwarn');
				var asktheuser = (thunderbrowseprefs.getBoolPref("warnjavascript") == false) ? true : confirm(protowarnbar);

				//check if the user said yes to run javascript
				if(asktheuser == true)
				{
					TBrowserCore.toggleContent(true); //js is obviously allowed. otherwise, we wouldn't be here.				
					var getcommand = urlRecieved.split("javascript:")[1]; //remove the javascript: and get what they typed
					try
					{
						if((/(components.classes|installtrigger)/i).test(getcommand) == false)
						{ 
							var remapdocument;
							/* we want to remap document because document doesn't really take you to real javascript document */
							if(tbrowser.contentDocument.defaultView.document.childNodes)
									remapdocument = getcommand.replace(/content.document/g,"tbrowser.contentDocument.defaultView.document");
							else
									remapdocument = getcommand.replace(/content.document/g,"tbrowser._docShell.document");
									
                            //This will run if the user themself types it in. Web code should fire via onclick, default elements handle (BUTTON) or crying.
							eval(remapdocument);
						}	
					}
					catch(e)
					{ 							
						/* Put the error into the console */
						TBrowseGlobal.tbLogMsg("javascript protocol code threw exception: "+e);
					}
				}
				/* if they pressed X or they clicked no */
				else 
					TBrowserCore.toggleContent(false);
					
				return true;
		  }
		  else if((/(^javascript)/i).test(urlProtocol) == true)
			return 0;

		  if((/(^custombutton)/i).test(urlProtocol) == true && $("CB2AddButt")) //Custom Button support
		  {
				 custombuttons.installWebButton(urlRecieved);
				 return 0;
		  }
				 
		  if((/(^whois)/i).test(urlProtocol) == true) //Whois protocol
		  {
				var urltolookup = urlRecieved.split(/(^whois:)/i);
				var replacewww = urltolookup[2].replace("www.","");
				var lowercase = replacewww.toLowerCase();
				this.launchURL("http://whois.domaintools.com/"+lowercase, tbrowser, null, null, null);	
				
				return 0;
		  }
		  
		  if((/(^source|^view-source)/i).test(urlProtocol) == true) //Viewing Source protocol
		  {
				 var theurl = urlRecieved.split(/(^source:|^view-source:)/i)[2];
				 TBrowseGlobal.viewSource(theurl);
				 return 0;
		  }
				 
		  if((/(^http(s)?)/i).test(urlProtocol) == true && notOnMailbox == true)
		  {
			  TBrowserCore.toggleContent(true);
			  if(isXPI == true) /* XPI support */
			  {
				  var filenamefind = urlRecieved.split("/");
				  var thefilenamepart =filenamefind.length-1;
				  var thefilename = filenamefind[thefilenamepart];
				  var xpi = new Array();
				  xpi[thefilename]=urlRecieved;
				  var canweinstall=InstallTrigger.enabled();
				  if(canweinstall==true)
					InstallTrigger.install(xpi,null);
				  return 0;
			  }
		  }
		  
		  //Was not handled by any other protocol check, fire to loader.

		  this.launchURL(urlRecieved, tbrowser, referUrl, postData, specialFlags);
		  
		}
		else if(TBrowseCommands.checkForUnknownProto(urlRecieved) == true) //Unsupported Protocols
			 return 0;	
	},

	launchURL: function launchURL(urlRecieved, originBrowser, referUrl, postData, specialFlags)
	{
		//hide mail widgets
		TBrowserCore.collapseBars();
		
		var charset = TBrowseGlobal.getCharset(originBrowser);
		
		if(postData != null)
		 postData = ThunderBrowseHandler.handlePostData(postData, charset);
		//if the browser exists
		if(originBrowser && TBrowsePermissions.linksAllowed() == true)
		{
		  //if avoiding history is not defined
		  if((specialFlags == null || specialFlags == "5") && (/(^mailto|^javascript)/i).test(urlRecieved) == false)
		  {
				 TBHistory.captureRecentUrls(originBrowser);
				 TBHistory.getBackHistory(originBrowser);
		  }
		  
		  //some websites use CODE=00, which will run in a continous login loop. CODE=01 fixes this.
		  if(urlRecieved.match("CODE=00") != null)
			  urlRecieved = urlRecieved.replace("CODE=00","CODE=01");
		 
		  //Check for about protocols. This will only return false if the about url is invalid.
		  urlRecieved = TBrowseCommands.checkAbout(urlRecieved) ? urlRecieved : "about:blank";
		  
		  var isAbout = (/(^about|^tbit)/i).test(urlRecieved);
		  
		  //load url
		  //also check if we are actually online or not
		  if(!$("ThunderBrowsePopup"))
		  {
			 var isOnline = (typeof CheckOnline == 'function') ? CheckOnline() : (MailOfflineMgr && MailOfflineMgr.isOnline());
			 if(isOnline == true || isAbout == true)
			 {
				  if(originBrowser.tab && isAbout == false && !(ThunderBrowseHandler.sameDomain(urlRecieved) == true && urlRecieved.split("#").length != 1))
				  {
					originBrowser.tab.isLoaded = false;
					TBrowserCore.throbberForTab(originBrowser.tab);
				  }
				  originBrowser.loadURIWithFlags(urlRecieved, null, referUrl, charset, postData);			
			 }
		  }
		  else
			 originBrowser.loadURIWithFlags(urlRecieved, null, referUrl, charset, postData);				 
		}
	}
};

//this is an original Thunderbird function rewrote so it includes our code
function ThreadPaneSelectionChanged() 
{
  ThunderTabBrowser.selectedTab = document.getElementById('mail-tab');
  if(gTBNavBar)	
    gTBNavBar.setAttribute("collapsed",thunderbrowseprefs.getBoolPref("hideme"));
  TBrowserCore.toggleContent(false);
  document.getElementById("messagepane").setAttribute("history-forward","");
  document.getElementById("messagepane").setAttribute("history-back","");
  if(gTBBack && gTBFwd)
  {
    gTBBack.setAttribute("disabled","true");
    gTBFwd.setAttribute("disabled","true");
  }
  TBrowserCore.getFavicon(document.getElementById("mail-tab"));
  if(typeof gMsgFolderSelected == 'undefined' && gFolderDisplay.displayedFolder)
    UpdateStatusMessageCounts(gFolderDisplay.displayedFolder);
  if(typeof gRightMouseButtonDown == 'undefined')
    var gRightMouseButtonDown = false; 
  if (!gRightMouseButtonDown) 
     GetThreadTree().view.selectionChanged();	
} 
